include N.inc

;**********************CODE SEGMENT*********************************
.code
start:;START PROG HERE. 
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	
	;Alloc buffers.
	malloc 2048
	mov pBuf_WorkGroup,eax

	malloc 2048
	mov pBuf_Computer,eax

	malloc 2048
	mov pBuf_Directory,eax

	malloc 2048
	mov pBuf_Suffixal,eax

	malloc 2048
	mov pTmpBuf,eax

	;create log file,we will store all outputs in this file.
	invoke CreateFile,SADD("List.log"),GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
	.if eax == INVALID_HANDLE_VALUE

		invoke OutputCRLF
		invoke OutputResult,SADD("List file create error happened!")		
		invoke ExitProcess,eax
	.endif
	mov hList,eax

	;parse  command line,and put contents to corresponding buffers.
	invoke ParseCommandline
	.if eax == 0
		invoke OutputCRLF
		invoke OutputResult,SADD("Please Check your input,I can not recognise it!")
		invoke ExitProcess,NULL
	.endif
	
	;now start enum local network

	invoke OutputCRLF
	invoke OutputResult,SADD("Now we start.")
	invoke Sleep,500
	
	invoke GetTickCount
	mov GD(STime),eax
	
	;main procedure,it will enum networks and call corresponding callback function by corresponding flags.
	invoke EnumNetObject,RESOURCEUSAGE_CONTAINER,NULL,offset EnumFromTop
	.if eax == 0		
		invoke OutputCRLF
		invoke OutputResult,SADD("  Enum Local Net error happened!")		
	.endif
	
	invoke OutputCRLF
	invoke OutputResult,SADD("Elased time is ")

	invoke GetTickCount
	;cacu elased time.
	sub eax,STime
	shr eax,10
	invoke dwtoa,eax,pTmpBuf
	invoke lstrcat,pTmpBuf,SADD("s")
	invoke OutputResult,pTmpBuf
	
	invoke CloseHandle,hList
	
	;free buffers
	free	pBuf_WorkGroup
	free	pBuf_Computer
	free	pBuf_Directory
	free	pBuf_Suffixal
	free	pTmpBuf

	invoke	ExitProcess,NULL

;===============================================================================\
;This will parse all command line to corresponding buffer,return false if       |
;we can't recognise it.                                                         |
;===============================================================================/
ParseCommandline  proc uses esi edi

	invoke GetCommandLine
	mov esi,eax
	Remove_Space	
	Remove_NoSpace
	Remove_Space;now we mov pointer to the start of parameter.
	
	.if byte ptr [esi] == NULL ; no parameter,then print versoin info.
		CRLF
		printf "	Local Net Enum tool by jingtaozf.",13,10,"	CopyRight (C)Smallwave's asm studio 2000-2002.",13,10,"	Usage:N /g WORKGROUP /c Computer /d Share Directory /s suffixal ",13,10,"	Enjoy it please! :)"
		CRLF
		invoke ExitProcess,NULL		
	.endif

Check_Input:
	.while BYTE ptr [esi] != NULL				
		.if	BYTE ptr [esi] != "/"
			xor eax,eax
			ret
		.endif

		inc esi
		or BYTE ptr [esi],20h
		.if BYTE ptr [esi] == "g"
			inc esi
			mov Flag_WorkGroup,TRUE
			jmp _GetWorkGroup

		.elseif BYTE ptr [esi] == "c"
			inc esi
			mov Flag_Computer,TRUE
			jmp _GetComputer
		.elseif BYTE ptr [esi] == "d"
			inc esi
			mov Flag_Directory,TRUE
			jmp _GetDirectory
		.elseif BYTE ptr [esi] == "s"
			inc esi
			mov Flag_Suffixal,TRUE
			jmp _GetSuffixal
		.elseif byte ptr [esi] == "a"
			mov Flag_HideDir,TRUE
			inc esi
			Remove_Space
			jmp Check_Input
		.else
			xor eax,eax
			ret
		.endif
	.endw

	mov eax,TRUE
	ret
;----------------------------------------------------\
;		Manipulate each situation					 |
;----------------------------------------------------/
_GetWorkGroup:
	mov edi,pBuf_WorkGroup
	jmp _ParseCommandline

_GetComputer:
	mov edi,pBuf_Computer
	jmp _ParseCommandline
	
_GetDirectory:
	mov edi,pBuf_Directory
	jmp _ParseCommandline

_GetSuffixal:
	mov edi,pBuf_Suffixal
	;jmp _ParseCommandline

_ParseCommandline:
	Remove_Space
	
	.if BYTE ptr [esi] != NULL && BYTE ptr [esi] != "/"
		;this is a valid input,we should put it into buffer.

		;find the end flag of buf,here should be two zeros,		
		.if BYTE ptr [edi] != NULL
			inc edi
			.while WORD ptr [edi] != NULL
				inc edi
			.endw
			inc edi
		.endif
			
		.while BYTE ptr [esi] != " " && BYTE ptr [esi] != NULL
			movsb
		.endw
				
		Remove_Space	
	.endif
	
	jmp Check_Input;continue to check next parameter.

ParseCommandline endp 


;============================================================================================\
;		##Out SearchResult,both to console and file.##									     |
;============================================================================================/
OutputResult  proc lpStr1:dword
local dwTmp:dword,dLen:dword,hOutput:dword
		
 	invoke lstrlen,lpStr1
	mov dLen,eax

    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hOutPut, eax
    
    invoke WriteFile,hOutPut,lpStr1,dLen,ADDR dwTmp,NULL
	invoke WriteFile,hList,lpStr1,dLen,addr dwTmp,NULL
	
	ret
OutputResult endp

;--------------------------------------------------------------------------------------------
OutputCRLF  proc 
local dwTmp:dword	
	
	CRLF
    invoke WriteFile,hList,SADD(13,10),2,addr dwTmp,0
    ret
OutputCRLF endp

;============================================================================================\
;##Enum local network from top to bottom and invoke callback func to manipulate subresult.## |
;============================================================================================/
EnumFromTop  proc uses esi lpNetRes:DWORD 
local lpRemoteName:dword	

	
	mov esi,lpNetRes
	assume esi:ptr  NETRESOURCE	
	mov eax,[esi].lpRemoteName
	mov lpRemoteName,eax
	assume esi:nothing
    
	invoke OutputCRLF
	invoke OutputResult,lpRemoteName
    	
	invoke EnumNetObject,RESOURCEUSAGE_CONTAINER,lpNetRes,offset EnumNetWorkGroup
	ret
EnumFromTop endp

;--------------------------------------------------------------------------------------------
EnumNetWorkGroup  proc uses esi edi lpNetRes:dword

	;if not specify this flag,just exit from this proc.
	.if Flag_WorkGroup == FALSE
		ret
	.endif

	mov esi,lpNetRes
	assume esi:ptr  NETRESOURCE	
	mov esi,[esi].lpRemoteName
	assume esi:nothing	
				
	.if Flag_ReachInputGroup == TRUE
		;we have manipulate the appionted workdgroup,so just exit.
		ret
	.endif

	mov edi,pBuf_WorkGroup
	.if BYTE ptr [edi] == NULL;if buf is null,then we should search all workgroup
	
		invoke OutputCRLF
		invoke OutputResult,SADD("Find WorkGroup: ")
		invoke OutputResult,esi

		invoke EnumNetObject,RESOURCEUSAGE_CONTAINER,lpNetRes,offset EnumNetComputer
		
	.else;else we only manipulate the appointed workgroup
		
		invoke lstrcmpi,esi,edi
		.if eax == NULL;if we find appointed workgroup,print it and call sub function.
			
			mov Flag_ReachInputGroup,TRUE
			
			invoke OutputCRLF
			invoke OutputCRLF
			invoke OutputResult,SADD("Find the workgroup you input: ")
			invoke OutputResult,esi			
			

			invoke EnumNetObject,RESOURCEUSAGE_CONTAINER,lpNetRes,offset EnumNetComputer
		.endif
	.endif		

	ret
EnumNetWorkGroup endp

;--------------------------------------------------------------------------------------------
EnumNetComputer  proc uses esi edi  lpNetRes:dword

	;if not specify this flag,just exit from this proc.
	.if Flag_Computer == FALSE
		ret
	.endif

	mov esi,lpNetRes
	assume esi:ptr  NETRESOURCE	
	mov esi,[esi].lpRemoteName
	assume esi:nothing

	.if Flag_ReachComputer == TRUE;we have manipulate the appointed computer,just exit.
		ret
	.endif

	mov edi,pBuf_Computer
	
	.if BYTE ptr [edi] == NULL;if not specify a computer,then show and call sub function.		
		
		invoke OutputCRLF
		invoke OutputResult,SADD("Find Computer: ")
		invoke OutputResult,esi

		invoke EnumNetObject,RESOURCEUSAGE_CONNECTABLE,lpNetRes,offset EnumNetComputerShareDir

	.else;else we only show and manipulate the specified computer.
		invoke lstrcpy,pTmpBuf,SADD("\\")
		invoke lstrcat,pTmpBuf,edi
		invoke lstrcmpi,esi,pTmpBuf
		.if eax == NULL;if find,show and call sub function.
			
			mov Flag_ReachComputer,TRUE
			
			invoke lstrcat,pTmpBuf,SADD("\test")
			invoke CreateFile,pTmpBuf,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_NEW,NULL,NULL
			.if eax != INVALID_HANDLE_VALUE		
				invoke CloseHandle,eax
				invoke DeleteFile,pTmpBuf
				mov ebx,TRUE
			.else
				mov ebx,FALSE
			.endif

			invoke OutputCRLF			
			invoke OutputResult,SADD("Find the Computer you input: ") 
			invoke OutputResult,esi

			invoke EnumNetObject,RESOURCEUSAGE_CONNECTABLE,lpNetRes,offset EnumNetComputerShareDir
		.endif
	.endif
	
	ret
EnumNetComputer endp

;--------------------------------------------------------------------------------------------
EnumNetComputerShareDir  proc uses esi ebx lpNetRes:DWORD 

	;if not specify this flag,just exit from this proc.
	.if Flag_Directory == FALSE
		
		ret
	.endif

	mov esi,lpNetRes
	assume esi:ptr  NETRESOURCE
	mov esi,[esi].lpRemoteName
	assume esi:nothing	
	
	.if Flag_ReachDirectory == TRUE;we have manipulate the appointed directory,so just exit now.
		
		ret
	.endif
	
	mov edi,pBuf_Directory
	
	.if BYTE ptr [edi] == NULL;if not specify a directory,then show all and call sub function.		
		invoke lstrcpy,pTmpBuf,esi
		invoke lstrcat,pTmpBuf,SADD("\test")
		invoke CreateFile,pTmpBuf,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_NEW,NULL,NULL
		.if eax != INVALID_HANDLE_VALUE		
			invoke CloseHandle,eax
			invoke DeleteFile,pTmpBuf
			mov ebx,TRUE
		.else
			mov ebx,FALSE
		.endif

		invoke OutputCRLF
		invoke OutputResult,SADD("    Find share directory: ")
		invoke OutputResult,esi

		.if ebx && Flag_HideDir == TRUE		
			invoke OutputResult,SADD(" (Writeable)")
		.endif

		invoke EnumFileObject,esi

	.else;else we only show and manipulate the specified directory.

		invoke lstrcpy,pTmpBuf,SADD("\\")
		invoke lstrcat,pTmpBuf,pBuf_Computer
		invoke lstrcat,pTmpBuf,SADD("\");
		invoke lstrcat,pTmpBuf,edi
		invoke lstrcmpi,esi,pTmpBuf
		.if eax == NULL;if find,show and call sub function.
			
			mov Flag_ReachDirectory,TRUE
			invoke lstrcat,pTmpBuf,SADD("\test")
			invoke CreateFile,pTmpBuf,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_NEW,NULL,NULL
			.if eax != INVALID_HANDLE_VALUE		
				invoke CloseHandle,eax
				invoke DeleteFile,pTmpBuf
				mov ebx,TRUE
			.else
				mov ebx,FALSE
			.endif

			invoke OutputCRLF
			invoke OutputResult,SADD("    Find share Directory you input: ")
			invoke OutputResult,edi
			.if Flag_HideDir == TRUE && ebx						
				invoke OutputResult,SADD(" (Writeable)"	)	
			.endif

			invoke EnumFileObject,esi
		.endif
	.endif

	ret
EnumNetComputerShareDir endp

;--------------------------------------------------------------------------------------------
EnumFileObject  proc uses esi edi ebx lpRemoteName:DWORD 
local FindFileData:WIN32_FIND_DATA,hFind:dword	
	
	;if not specify this flag,just exit from this proc.
	.if Flag_Suffixal == FALSE		
		ret	
	.endif

	invoke SetCurrentDirectory,lpRemoteName
	.if eax == NULL
		
		xor eax,eax
		ret
	.endif	

	invoke FindFirstFile,SADD("*.*"),addr FindFileData
	.if eax == INVALID_HANDLE_VALUE
		
		invoke SetCurrentDirectory,SADD("..")
		xor eax,eax
		ret		
	.endif
	mov hFind,eax
		
	.repeat
				
		lea esi,FindFileData
		assume esi:ptr WIN32_FIND_DATA
		.if [esi].dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY
			
			 .if  BYTE ptr [esi].cFileName != "."
			
				IFDEF Debug
							invoke OutputCRLF
							invoke OutputResult,SADD("	Find sub Directory ")
							invoke GetCurrentDirectory,MAX_PATH,pTmpBuf
							invoke lstrcat,pTmpBuf,SADD("\")
							invoke lstrcat,pTmpBuf,addr [esi].cFileName
							invoke OutputResult,pTmpBuf
				ENDIF
			
				invoke EnumFileObject,addr [esi].cFileName			
			.endif
		
		.else;if a file, declare its suffixal.			
			
			mov edi,pBuf_Suffixal
			mov eax,edi
			.while BYTE ptr [edi] != NULL
				inc edi
			.endw
			.while BYTE ptr [edi] != "." && eax != edi
				dec edi
			.endw
			inc edi;go to the part of suffixal.

			.if BYTE ptr [edi] == "*";if *.*,list all.
				
				invoke ListFileObject,addr [esi].cFileName	
			.else
			
				lea ebx,[esi].cFileName
				mov eax,ebx
				.while BYTE ptr [ebx] != NULL	
					inc ebx
				.endw
					
				.while BYTE ptr [ebx] != "." && eax != ebx
					dec ebx
				.endw
				inc ebx;go to the part of suffixal

				invoke lstrcmpi,edi,ebx
				.if eax == NULL

					invoke ListFileObject,addr [esi].cFileName		
				.endif				
			.endif			
		.endif		
	invoke FindNextFile,hFind,addr FindFileData
	.until (eax == FALSE)
	
	invoke FindClose,hFind
	invoke SetCurrentDirectory,SADD("..")
	ret
EnumFileObject endp

;--------------------------------------------------------------------------------------------
ListFileObject  proc lpFileName:DWORD

	invoke OutputCRLF
	invoke OutputResult,SADD("		Find File: ")
	
	invoke GetCurrentDirectory,MAX_PATH,pTmpBuf
	invoke lstrcat,pTmpBuf,SADD("\")
	invoke lstrcat,pTmpBuf,lpFileName
	invoke OutputResult,pTmpBuf

	
	ret
ListFileObject endp

;============================================================================================\
;		##Main proc that enum the local net in sam level and invoke the callback func.##     |
;============================================================================================/
EnumNetObject  proc uses ebx esi edi dwUsage:dword,lpNetRes:dword,CallBack:dword
local hEnum:dword

	invoke WNetOpenEnum,RESOURCE_GLOBALNET,RESOURCETYPE_DISK,dwUsage,lpNetRes,addr hEnum
	.if eax != NULL
		
		CRLF
		printf "Open Enum Error!"
		xor eax,eax
		ret
	.endif
	
	.while TRUE
				
		mov ecx,1024
		push ecx
		mov ecx,esp;lpsize

		mov eax,1
		push eax
		mov eax,esp;lpcCount
		invoke WNetEnumResource,hEnum,eax,pTmpBuf,ecx		
		.break .if eax != NO_ERROR
		
		mov eax,pTmpBuf
		push eax
		call CallBack
	.endw
	
	ret
EnumNetObject endp

end	start



